<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Api\Command;

use Sylius\Bundle\ApiBundle\Command\IriToIdentifierConversionAwareInterface;
use Sylius\Bundle\ApiBundle\Command\OrderTokenValueAwareInterface;

class AddInternalCommentToQuote implements OrderTokenValueAwareInterface, IriToIdentifierConversionAwareInterface
{
    public ?string $orderTokenValue;

    public function __construct(
        public ?string $comment,
        public int $user,
    ) {
    }

    public static function createFromData(
        string $tokenValue,
        string $comment,
        int $user,
    ): self {
        $command = new self($comment, $user);

        $command->orderTokenValue = $tokenValue;

        return $command;
    }

    public function getOrderTokenValue(): ?string
    {
        return $this->orderTokenValue;
    }

    public function setOrderTokenValue(?string $orderTokenValue): void
    {
        $this->orderTokenValue = $orderTokenValue;
    }
}
