<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Api\Command;

use Sylius\Bundle\ApiBundle\Command\IriToIdentifierConversionAwareInterface;
use Sylius\Bundle\ApiBundle\Command\OrderTokenValueAwareInterface;

class AddItemToQuote implements OrderTokenValueAwareInterface, IriToIdentifierConversionAwareInterface
{
    public ?string $orderTokenValue;

    public function __construct(
        public string $productVariantCode,
        public int $quantity,
        public int $unitPrice,
    ) {
    }

    public static function createFromData(
        string $tokenValue,
        string $productVariantCode,
        int $quantity,
        int $unitPrice,
    ): self {
        $command = new self($productVariantCode, $quantity, $unitPrice);

        $command->orderTokenValue = $tokenValue;

        return $command;
    }

    public function getOrderTokenValue(): ?string
    {
        return $this->orderTokenValue;
    }

    public function setOrderTokenValue(?string $orderTokenValue): void
    {
        $this->orderTokenValue = $orderTokenValue;
    }
}
