<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Api\Command;

use Sylius\Bundle\ApiBundle\Command\ChannelCodeAwareInterface;
use Sylius\Bundle\ApiBundle\Command\CustomerEmailAwareInterface;

class PickupQuote implements ChannelCodeAwareInterface, CustomerEmailAwareInterface
{
    public ?string $tokenValue;

    public ?string $localeCode;

    private ?string $channelCode;

    public ?string $email = null;

    public function __construct(?string $tokenValue = null, ?string $localeCode = null)
    {
        $this->tokenValue = $tokenValue;
        $this->localeCode = $localeCode;
    }

    public function getChannelCode(): ?string
    {
        return $this->channelCode;
    }

    public function setChannelCode(?string $channelCode): void
    {
        $this->channelCode = $channelCode;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(?string $email): void
    {
        $this->email = $email;
    }
}
