<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Api\Command;

use Sylius\Bundle\ApiBundle\Command\OrderTokenValueAwareInterface;

class RemoveQuote implements OrderTokenValueAwareInterface
{
    public function __construct(public ?string $orderTokenValue)
    {
    }

    public static function removeFromData(string $tokenValue): self
    {
        return new self($tokenValue);
    }

    public function getOrderTokenValue(): ?string
    {
        return $this->orderTokenValue;
    }

    public function setOrderTokenValue(?string $orderTokenValue): void
    {
        $this->orderTokenValue = $orderTokenValue;
    }
}
