<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Api\Command;

use Sylius\Bundle\ApiBundle\Command\IriToIdentifierConversionAwareInterface;
use Sylius\Bundle\ApiBundle\Command\OrderTokenValueAwareInterface;
use Sylius\Bundle\ApiBundle\Command\SubresourceIdAwareInterface;

class UpdateInternalCommentFromQuote implements
    OrderTokenValueAwareInterface,
    IriToIdentifierConversionAwareInterface,
    SubresourceIdAwareInterface
{
    public ?string $orderTokenValue;

    public ?string $commentId;

    public function __construct(
        public ?string $comment,
    ) {
    }

    public static function createFromData(
        string $tokenValue,
        string $commentId,
        string $comment,
    ): self {
        $command = new self($comment);

        $command->orderTokenValue = $tokenValue;
        $command->commentId = $commentId;

        return $command;
    }

    public function getOrderTokenValue(): ?string
    {
        return $this->orderTokenValue;
    }

    public function setOrderTokenValue(?string $orderTokenValue): void
    {
        $this->orderTokenValue = $orderTokenValue;
    }

    public function getSubresourceId(): ?string
    {
        return $this->commentId;
    }

    public function setSubresourceId(?string $subresourceId): void
    {
        $this->commentId = $subresourceId;
    }

    public function getSubresourceIdAttributeKey(): string
    {
        return 'commentId';
    }
}
