<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Api\Command;

use Sylius\Bundle\ApiBundle\Command\IriToIdentifierConversionAwareInterface;
use Sylius\Bundle\ApiBundle\Command\OrderTokenValueAwareInterface;
use Sylius\Bundle\ApiBundle\Command\SubresourceIdAwareInterface;

class UpdateItemFromQuote implements
    OrderTokenValueAwareInterface,
    IriToIdentifierConversionAwareInterface,
    SubresourceIdAwareInterface
{
    public ?string $orderTokenValue;

    public ?string $itemId;

    public function __construct(
        public ?int $quantity,
        public ?int $unitPrice = null,
    ) {
    }

    public static function createFromData(
        string $tokenValue,
        string $itemId,
        ?int $quantity,
        ?int $unitPrice,
    ): self {
        $command = new self($quantity, $unitPrice);

        $command->orderTokenValue = $tokenValue;
        $command->itemId = $itemId;

        return $command;
    }

    public function getOrderTokenValue(): ?string
    {
        return $this->orderTokenValue;
    }

    public function setOrderTokenValue(?string $orderTokenValue): void
    {
        $this->orderTokenValue = $orderTokenValue;
    }

    public function getSubresourceId(): ?string
    {
        return $this->itemId;
    }

    public function setSubresourceId(?string $subresourceId): void
    {
        $this->itemId = $subresourceId;
    }

    public function getSubresourceIdAttributeKey(): string
    {
        return 'itemId';
    }
}
