<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Api\Command;

use Sylius\Bundle\ApiBundle\Command\OrderTokenValueAwareInterface;

class UpdateQuoteInformation implements OrderTokenValueAwareInterface
{
    public ?string $orderTokenValue = null;

    public ?string $customerComment = null;

    public ?string $informationComment = null;

    public ?string $expirationDate = null;

    public ?int $total = null;

    public function __construct(
        ?string $customerComment = null,
        ?string $informationComment = null,
        ?string $expirationDate = null,
        ?int $total = null,
    ) {
        $this->customerComment = $customerComment;
        $this->informationComment = $informationComment;
        $this->expirationDate = $expirationDate;
        $this->total = $total;
    }

    public function getOrderTokenValue(): ?string
    {
        return $this->orderTokenValue;
    }

    public function setOrderTokenValue(?string $orderTokenValue): void
    {
        $this->orderTokenValue = $orderTokenValue;
    }

    public function getCustomerComment(): ?string
    {
        return $this->customerComment;
    }

    public function setCustomerComment(?string $customerComment): void
    {
        $this->customerComment = $customerComment;
    }

    public function getInformationComment(): ?string
    {
        return $this->informationComment;
    }

    public function setInformationComment(?string $informationComment): void
    {
        $this->informationComment = $informationComment;
    }

    public function getExpirationDate(): ?string
    {
        return $this->expirationDate;
    }

    public function setExpirationDate(?string $expirationDate): void
    {
        $this->expirationDate = $expirationDate;
    }

    public function getTotal(): ?int
    {
        return $this->total;
    }

    public function setTotal(?int $total): void
    {
        $this->total = $total;
    }
}
