<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Api\Handler;

use Dedi\SyliusQuotePlugin\Api\Command\RemoveInternalCommentFromQuote;
use Dedi\SyliusQuotePlugin\Entity\InternalCommentInterface;
use Dedi\SyliusQuotePlugin\Repository\InternalCommentRepositoryInterface;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\Messenger\Attribute\AsMessageHandler;
use Webmozart\Assert\Assert;

#[AsMessageHandler]
class RemoveInternalCommentFromQuoteHandler
{
    public function __construct(
        private readonly InternalCommentRepositoryInterface $internalCommentRepository,
        private readonly EntityManagerInterface $entityManager,
    ) {
    }

    public function __invoke(RemoveInternalCommentFromQuote $removeInternalCommentFromQuote): void
    {
        /** @var InternalCommentInterface|null $comment */
        $comment = $this->internalCommentRepository->findByIdAndQuoteTokenValue(
            $removeInternalCommentFromQuote->commentId,
            $removeInternalCommentFromQuote->getOrderTokenValue(),
        );

        Assert::notNull($comment);

        $this->entityManager->remove($comment);
    }
}
