<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Api\Handler;

use Dedi\SyliusQuotePlugin\Api\Command\RemoveQuote;
use Dedi\SyliusQuotePlugin\Entity\OrderInterface;
use Dedi\SyliusQuotePlugin\Repository\QuoteRepositoryInterface;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\Messenger\Attribute\AsMessageHandler;
use Webmozart\Assert\Assert;

#[AsMessageHandler]
class RemoveQuoteHandler
{
    public function __construct(
        private readonly QuoteRepositoryInterface $quoteRepository,
        private readonly EntityManagerInterface $entityManager,
    ) {
    }

    public function __invoke(RemoveQuote $removeQuote): void
    {
        /** @var OrderInterface|null $quote */
        $quote = $this->quoteRepository->findOneByTokenValue($removeQuote->orderTokenValue);

        Assert::notNull($quote);

        $this->entityManager->remove($quote);
    }
}
