<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Api\Handler;

use Dedi\SyliusQuotePlugin\Api\Command\UpdateInternalCommentFromQuote;
use Dedi\SyliusQuotePlugin\Entity\InternalCommentInterface;
use Dedi\SyliusQuotePlugin\Repository\InternalCommentRepositoryInterface;
use Symfony\Component\Messenger\Attribute\AsMessageHandler;
use Webmozart\Assert\Assert;

#[AsMessageHandler]
class UpdateInternalCommentFromQuoteHandler
{
    public function __construct(
        private readonly InternalCommentRepositoryInterface $internalCommentRepository,
    ) {
    }

    public function __invoke(UpdateInternalCommentFromQuote $updateInternalCommentFromQuote): ?InternalCommentInterface
    {
        /** @var InternalCommentInterface|null $internalComment */
        $internalComment = $this->internalCommentRepository->findByIdAndQuoteTokenValue(
            $updateInternalCommentFromQuote->getSubresourceId(),
            $updateInternalCommentFromQuote->getOrderTokenValue(),
        );

        Assert::notNull($internalComment);

        $comment = $updateInternalCommentFromQuote->comment;

        if (null !== $comment) {
            $internalComment->setComment($comment);
        }

        return $internalComment;
    }
}
