<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Repository;

use Dedi\SyliusQuotePlugin\Entity\InternalCommentInterface;
use Sylius\Bundle\ResourceBundle\Doctrine\ORM\EntityRepository;

class InternalCommentRepository extends EntityRepository implements InternalCommentRepositoryInterface
{
    public function findByIdAndQuoteTokenValue($id, $tokenValue): ?InternalCommentInterface
    {
        return $this->createQueryBuilder('i')
            ->innerJoin('i.quoteInformation', 'qi')
            ->innerJoin('qi.order', 'o')
            ->andWhere('i.id = :id')
            ->andWhere('o.tokenValue = :tokenValue')
            ->setParameters([
                'id' => $id,
                'tokenValue' => $tokenValue,
            ])
            ->getQuery()
            ->getOneOrNullResult();
    }
}
